<%@ page contentType="text/html; charset=UTF-8" %>

<%@ page import="com.crystaldecisions.enterprise.ocaframework.ServiceNames"%>
<%@ page import="com.crystaldecisions.sdk.exception.SDKException"%>
<%@ page import="com.crystaldecisions.sdk.occa.infostore.*"%>
<%@ page import="com.crystaldecisions.sdk.occa.infostore.CePropertyID"%>
<%@ page import="com.crystaldecisions.sdk.occa.pluginmgr.*"%>
<%@ page import="com.crystaldecisions.sdk.plugin.CeProgID"%>
<%@ page import="com.crystaldecisions.sdk.plugin.desktop.user.*"%>
<%@ page import="com.crystaldecisions.sdk.properties.*"%>
<%@ page import="com.crystaldecisions.sdk.framework.CrystalEnterprise" %>
<%@ page import="com.crystaldecisions.sdk.framework.IEnterpriseSession" %>
<%@ page import="com.crystaldecisions.sdk.framework.ISessionMgr" %>
<%@ page import="javax.servlet.http.Cookie" %>
<%@ page import="java.util.*"%>
<%@ page import="java.lang.*"%>
<%@ page import="sun.net.smtp.SmtpClient, java.io.*" %> 
<%@ page errorPage="error.jsp" %>

<%!

public String resetPassword(IInfoStore infoStore, String firstN, String lastN) {
    IInfoObjects users= null;
    String HTMLString = "";
    String MailString="";
    String emailId="";
    String pass="";
    String userId="";
    String FullName=firstN + " " +lastN;

    pass=passwordGenerator();	
    
    try{
    	users = infoStore.query("SELECT SI_ID, SI_EMAIL_ADDRESS, SI_GUID FROM CI_SYSTEMOBJECTS "+ "WHERE SI_PROGID='CrystalEnterprise.USER'" + "And SI_USERFULLNAME='"+FullName+"'");

	if (users.size() == 0 ) {
	    // The query returned a blank collection (no object found).
           HTMLString = "<option value='0' disabled>No user accounts found";
	}
	else{
	IInfoObject iUser = (IInfoObject) users.get(0);
      emailId=((IUser)iUser).getEmailAddress();
      if(emailId.equalsIgnoreCase("")){
       HTMLString="Email Address for this account not available, please contact help desk";
       }
    	// Reset the user's password to NewPassword.
    	else{
      ((IUser)iUser).setNewPassword (pass);
      ((IUser)iUser).setPasswordToChangeAtNextLogon (true);
      userId=((IUser)iUser).getTitle();
    	//Commit the user with the new password to the CMS.
	infoStore.commit(users);
      HTMLString= "User: " + firstN + " " + lastN + " has been successfully reset and the new password is automatically emailed to: "+ emailId;
      }

    
     MailString="Userid: " + userId + " has been successfully reset to a new password: " + pass; 
        //Email sending code
        //Enter the From Email Address of the mail, this is what the user gets in the From Address when he gets the password reset mail.
        String from="BOADMIN-DoNotReply@YourCompany.com"; 
        String to=emailId;
        try{ 
          //Enter you SMTP client
          SmtpClient client = new SmtpClient("mail.sdg.ie.intuit.com"); 
          client.from(from); 
          client.to(to); 
          PrintStream message = client.startMessage(); 
          message.println("To: " + to); 
          //Subject of the mail 
          message.println("Subject: Your BOXI Password has been reset"); 
          //Body of the mail
          message.println("Please make sure to change your password on the next logon, else your account might get disabled. ");
          message.println();
          message.println(MailString);
          message.println();
          message.println("Log in to BOXI: http://infoviewURL"); 
          message.println(); 
          client.closeServer(); 
           } 
       catch (IOException e){ 
            System.out.println("ERROR SENDING EMAIL:"+e);
           }

          }
	} catch (SDKException e) {
            throw new Error("Failed to reset the user's password. Exception caught: " 
          					+ e.getMessage());
    } catch (NullPointerException e) {
          throw new Error("Failed to reset the user's password. Exception caught: "
          					+ e.getMessage());
    }

 return HTMLString;

}

public String passwordGenerator(){
Random rand = new Random(); 
int length = 8; 
char[] password = new char[8]; 
for (int x = 0; x < length; x++) { 
int randDecimalAsciiVal = rand.nextInt(93) + 33; 
password[x] = (char) randDecimalAsciiVal; 
} 
return String.valueOf(password); 

}

%> 



<%
// Retrieve the InfoStore object.
IInfoStore infoStore = (IInfoStore) session.getAttribute("InfoStore");

// If the InfoStore object is not found then display an error message.
if (infoStore == null) {
    throw new Error("InfoStore object not found. Please logon again.");
}

// Retrieve the user ID.
String firstName = request.getParameter("first");
String lastName = request.getParameter("last");
if(firstName.equalsIgnoreCase("")|| lastName.equalsIgnoreCase("") ){
out.println("Please enter both First and Last Names");
}
else
out.println(resetPassword(infoStore, firstName,lastName));


%>

<html>
    <head>
	<link rel="stylesheet" type="text/css" name="stylelink" href="../tutss.css">
    </head>

    <body>
		
	<hr>

	<form method="get" action="GetUsersName.jsp">
	    <input class="button" type="submit" value='Back'>
	    
	</form>
<a class="tut" href='logoff.jsp'><class="button">EXIT</a>
      
    </body>
</html>

