
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="com.crystaldecisions.sdk.exception.SDKException" %>
<%@ page import="com.crystaldecisions.sdk.framework.CrystalEnterprise" %>
<%@ page import="com.crystaldecisions.sdk.framework.IEnterpriseSession" %>
<%@ page import="com.crystaldecisions.sdk.framework.ISessionMgr" %>
<%@ page import="com.crystaldecisions.sdk.occa.infostore.IInfoStore" %>
<%@ page import="com.crystaldecisions.sdk.occa.managedreports.*" %>
<%@ page import="com.crystaldecisions.sdk.occa.security.ILogonTokenMgr" %>
<%@ page import="javax.servlet.http.Cookie" %>

<%
    // Set the expiration header.
    response.setHeader( "Expire", "0" );
%>

<link REL=STYLESHEET TYPE="text/css" HREF="tut.css">
<html>
<body>
<%

    // Enter your CMS Name
    String cms = "Your CMS Name";
    //Enter your Admin equivalent User Id
    String username = "An ID used to reset"; 
    //Password for the ID entered above
    String password = "Password"; 
    String auth = "secEnterprise";


    IEnterpriseSession enterpriseSession = null;
    ISessionMgr sessionMgr = CrystalEnterprise.getSessionMgr();
    Exception failure = null;
    boolean loggedIn = true;

	// If no session already exists, logon using the specified parameters.

    if (enterpriseSession == null)
    {
        try
        {

            // Attempt logon. Create an Enterprise session
            // manager object.
            ISessionMgr sm = CrystalEnterprise.getSessionMgr();

            // Log on to BusinessObjects Enterprise
            enterpriseSession = sm.logon(username, password, cms, auth);


        }
        catch (Exception error)
        {
            loggedIn = false;
            failure = error;
        }

        if (!loggedIn)
        {
            // If the login failed, redirect the user to the start page.
            out.println("<SCRIPT language=\"javascript\"> " +
                        " alert (\"Sorry - you could not be logged on to this server." +
                        " Ensure that your user name and password, as well as the CMS name are correct." +
                        "\");</SCRIPT>");
            out.println("<META HTTP-EQUIV='refresh' CONTENT='0;URL=start.jsp'>");
            return;
        }
        else
        {
            // Store the IEnterpriseSession object in the session.
            session.setAttribute("EnterpriseSession", enterpriseSession);

            // Create the IInfoStore object.
            IInfoStore iStore = (IInfoStore) enterpriseSession.getService("InfoStore");

            // Store the IInfoStore object in the session using the
            // helper functions.
            session.setAttribute("InfoStore", iStore);
            
            // Store the CMS name for later use.
            session.setAttribute("CMS", cms);
            
            // Store the logon token for later use.
            session.setAttribute("token", enterpriseSession.getLogonTokenMgr().getDefaultToken());

			// Create the IReportSourceFactory object.
			IReportSourceFactory reportSourceFactory = (IReportSourceFactory) enterpriseSession.getService("PSReportFactory");

			// Store the IReportSourceFactory object in the session
	            // using the helper functions.
			session.setAttribute("ReportSourceFactory", reportSourceFactory);

            // Retrieve the logon token manager.
            ILogonTokenMgr logonTokenMgr = enterpriseSession.getLogonTokenMgr();

            // Retrieve a logon token and store it in the user's cookie
            // file for use later.
            Cookie cookie = new Cookie("LogonToken", logonTokenMgr.createLogonToken("", 10, 100));
            response.addCookie(cookie);
        }
    }

	// Redirect the user to the relevant tutorial page.
	response.sendRedirect ("links.jsp");
%>
</body>
</html>
